######################### SETTINGS #################################
# Set left mouse button active
active_buttons = 1;
button_codes = 1; 

# Enable logging of responses.
response_logging = log_active; 

# Set correct answer property
stimulus_properties = correct, number;
event_code_delimiter = ";";


# Set default font to Arial to match instructions font.
default_font = "Arial";
# Set font size
default_font_size = 48;

begin;

#################### STIMULUS INITIALIZATION #######################
# Initialize stimulus array
array {
   text { caption = "WOLLE"; description = "1"; } A ;
   text { caption = "TERMITÄT"; description = "0"; } ;
   text { caption = "ENORM"; description = "1"; } ;
   text { caption = "WELSTBAR"; description = "0"; } ;
   text { caption = "REUEVOLL"; description = "1"; } ;
   text { caption = "ZUOBERST"; description = "1"; } ;
   text { caption = "RUPPIG"; description = "1"; } ;
   text { caption = "PETURAT"; description = "0"; } ;
   text { caption = "KLAGLOS"; description = "1"; } ;
   text { caption = "ZUGIG"; description = "1"; } ;
   text { caption = "TURBULENZ"; description = "1"; } ;
   text { caption = "ZEHE"; description = "1"; } ;
   text { caption = "DEGERATION"; description = "0"; } ;
   text { caption = "UNTIEF"; description = "1"; } ;
   text { caption = "ZÜCHTUNG"; description = "1"; } ;
   text { caption = "PENSIONAT"; description = "1"; } ;
   text { caption = "ZAPFEN"; description = "1"; } ;
   text { caption = "STAKSIG"; description = "1"; } ;
   text { caption = "STALMEN"; description = "0"; } ;
   text { caption = "MALZ"; description = "1"; } ;
   text { caption = "FEIGE"; description = "1"; } ;
   text { caption = "FÜRREN"; description = "0"; } ;
   text { caption = "RASEND"; description = "1"; } ;
   text { caption = "FEIST"; description = "1"; } ;
   text { caption = "KLEMPNER"; description = "1"; } ;
   text { caption = "AUSREBEN"; description = "0"; } ;
   text { caption = "KANNIBALE"; description = "1"; } ;
   text { caption = "SCHWACHHEIT"; description = "1"; } ;
   text { caption = "ERBARMEN"; description = "1"; } ;
   text { caption = "VERMASTIGEN"; description = "0"; } ;
   text { caption = "SUBVERSIV"; description = "1"; } ;
   text { caption = "SATTELN"; description = "1"; } ;
   text { caption = "PLANG"; description = "0"; } ;
   text { caption = "EIMERWEISE"; description = "1"; } ;
   text { caption = "SCHEIL"; description = "0"; } ;
   text { caption = "STOCKFEST"; description = "0"; } ;
   text { caption = "MEHLIG"; description = "1"; } ;
   text { caption = "DÄMMRIG"; description = "1"; } ;
   text { caption = "GAREN"; description = "1"; } ;
   text { caption = "TRACHTER"; description = "0"; } ;
   text { caption = "ANPROBE"; description = "1"; } ;
   text { caption = "MONSTRÖS"; description = "1"; } ;
   text { caption = "SONITÄT"; description = "0"; } ;
   text { caption = "SPEICHERUNG"; description = "1"; } ;
   text { caption = "MALODIE"; description = "0"; } ;
   text { caption = "NARKE"; description = "0"; } ;
   text { caption = "STRÄHNE"; description = "1"; } ;
   text { caption = "DESTILLATION"; description = "1"; } ;
   text { caption = "LEUCHTE"; description = "1"; } ;
   text { caption = "FLINTE"; description = "1"; } ;
   text { caption = "MACKEL"; description = "0"; } ;
   text { caption = "ENTSACHTUNG"; description = "0"; } ;
   text { caption = "GEOGRAPH"; description = "1"; } ;
   text { caption = "SUMMIERUNG"; description = "1"; } ;
   text { caption = "WAGHALSIG"; description = "1"; } ;
   text { caption = "ZIERDE"; description = "1"; } ;
   text { caption = "FAUNIK"; description = "0"; } ;
   text { caption = "LUDAL"; description = "0"; } ;
   text { caption = "KLAMM"; description = "1"; } ;
   text { caption = "DRAUNIG"; description = "0"; } ;
   text { caption = "FLISTOR"; description = "0"; } ;
   text { caption = "UNSTETIG"; description = "1"; } ;
   text { caption = "HERZIG"; description = "1"; } ;
} words;

# Initialize instruction slide
picture { bitmap { filename = "germanInstructions.bmp"; preload = true; }instbmp; 
x=0; y=0;
}instructionsbmp;

picture {text {caption = " "; font_size = 50;}t_result; x=0; y=0;
}p_result;

picture {arrow_graphic {coordinates = 7, -7, -7, 7; 
								line_width = 2;
								color = 255, 255, 255;
								head_width = 10;
								head_length = 10;
							  }arrow1; x = 0; y = 0;
							  
			text {caption = " "; font_size = 50;}t_trial; x=0; y=100;

			box { color = 255,0,0; height = 100; width = 200; } box1; x=-150; y=-100;   
			box { color = 0,255,0; height = 100; width = 200; } box2; x= 150; y=-100;   
			text { caption = "nein"; font_size = 36; background_color = 255,0,0 ; font_color = 0,0,0;} no; x=-150; y=-100;   
			text { caption = "ja"; font_size = 36; background_color = 0,255,0 ; font_color = 0,0,0;} yes; x=150; y=-100;   

}p_trial;

##################### TRIAL INITIALIZATION ####################################
# Instruction trial
trial {
   trial_duration = forever;
   trial_type = first_response;
   picture instructionsbmp;
	code = "instructiontrial";
   time = 0;
   duration = response;
 } instruction_trial;


#################### PCL PART STARTS HERE #####################################
begin_pcl;

#-----------------------------Definne used variables------------------------------------
array <int> aiResultWord[words.count()];			# define result arrays
array <int> aiResultNonWord[words.count()];		

int count_old;

mouse mse = response_manager.get_mouse( 1 );

int iMouseX;
int iMouseY;

int iObjectCount = 9;
array <string> asMST [iObjectCount] [4];

int iMouseInObject = 0;

string templog;
output_file ofile1 = new output_file;

#-----------------------------WaitForAllButtonpress------------------------------------
sub WaitForAllButtonpress begin
 
   loop 
	count_old = response_manager.total_response_count();	
	
	until (response_manager.total_response_count() > count_old) 
   begin end;
end;

#-----------------------------CreateMouseSensitiveText-------------------
sub CreateMouseSensitiveArea (int objectno, int left_x, int right_x, int lower_y, int upper_y) 
begin

	asMST[objectno][1] = string (left_x);
	asMST[objectno][2] = string (right_x);
	asMST[objectno][3] = string (lower_y);
	asMST[objectno][4] = string (upper_y);
	
end;

#-----------------------------InitMouseAreas -------------------
sub InitMouseAreas 
begin
	CreateMouseSensitiveArea (1, -250, -50, -150, -50);						# create rectangle sensitive area
	CreateMouseSensitiveArea (2, 50, 250, -150, -50);

	p_trial.set_part_on_top (1, true);											# the arrow has to be on top


end;

#-----------------------------IsMouseInObject-------------------
sub IsMouseInObject
begin
	loop int ii = 1 until ii > iObjectCount
	begin
		if ((iMouseX > int (asMST[ii][1])) && (iMouseX < int (asMST[ii][2])) && 
			(iMouseY > int (asMST[ii][3])) && (iMouseY < int (asMST[ii][4])))
		then 
			iMouseInObject = ii;
			break;
		else
			iMouseInObject = 0;
		end;
		
		ii = ii + 1;
	end;

end;

#-----------------------------MouseGetOnlyPosition-------------------
sub MouseGetOnlyPosition 
begin
		mse.poll();
		iMouseX = mse.pos( 1 );
		iMouseY = mse.pos( 2 );
end;


#-----------------------------WaitforMouseclick-------------------
sub WaitforMouseclick
begin	
	loop count_old = response_manager.total_response_count();	
		until ((response_manager.total_response_count() > count_old) && (iMouseInObject != 0))
	begin
		MouseGetOnlyPosition();
		p_trial.set_part_x(1, iMouseX);
		p_trial.set_part_y(1, iMouseY);
		IsMouseInObject();
		
		if (iMouseInObject == 1)
		then
			box1.set_color (128,0,0);
			no.set_background_color (128,0,0);
			box2.set_color (0,255,0);
			yes.set_background_color(0,255,0);
		elseif (iMouseInObject == 2)
		then
			box1.set_color (255,0,0);
			no.set_background_color (255,0,0);
			box2.set_color (0,128,0);
			yes.set_background_color(0,128,0);
		else
			box1.set_color (255,0,0);
			no.set_background_color (255,0,0);
			box2.set_color (0,255,0);
			yes.set_background_color(0,255,0);
		end;
		
		no.redraw();
		yes.redraw();
		p_trial.present();
	end;
end;

#-----------------------------CreateOutput------------------------------------
sub CreateOutput(string str ) begin

	templog = "";

   templog.append("Scenario - GermanLexTALE\n");
   templog.append("Logfile written - " + date_time() + "\n");
   templog.append("Subject: " + logfile.subject() + "\n\n");
  
   ofile1 = new output_file;
   ofile1.open( str, true ); # don't overwrite

   ofile1.print( templog );
   ofile1.close();

end; 

############################## Begin of the experiment #################################

CreateOutput(logfile.subject() + "_" + "score.txt");				# create Header of the output file

loop int k=1 until k>words.count()								# initialize result arrays with zeroes
begin
	aiResultWord[k] = 0;
	aiResultNonWord[k] = 0;
	k=k+1;
end;

InitMouseAreas();														# deine the mouse senisive areas

instruction_trial.present();										# Present instruction trial

loop int i = 1 until i > words.count() 						# Loop through stimulus trials
begin

   t_trial.set_caption(words[i].caption());
   t_trial.redraw();
   p_trial.present();
   
   WaitforMouseclick();
   
   if (int(words[i].description()) == 1)						# is it a word ?
   then
		if (iMouseInObject == 2)									# was the response "yes"?
		then
			aiResultWord[i] = 1;
		end;
	else
		if (iMouseInObject == 1)									# was the response "no"?
		then
			aiResultNonWord[i] = 1;
		end;		
	end;
	
   i = i + 1
end;

double dResultWord = 0;												# define result variables
double dResultNonWord = 0;
double dResult;
	
loop int k=4 until k>words.count()							# count the correct responses and ignore the first 3 trials (they are dummy trials)
begin
	dResultWord = dResultWord + aiResultWord[k];
	dResultNonWord = dResultNonWord + aiResultNonWord[k];
	k=k+1;
end;

dResult = (((100*dResultWord)/40) + ((100*dResultNonWord)/20)) / 2;	# calculate the final score

term.print("Number of correctly identified words: ");						# write information to terminal screen
term.print(dResultWord);
term.print("\n");
term.print("Number of correctly identified non-words: ");
term.print(dResultNonWord);
term.print("\n");
term.print("Total score: " + string(dResult));	

	
t_result.set_caption("Score: " + string(dResult));
t_result.redraw();
p_result.present();

templog = "";

templog.append("Number of correctly identified words: " + string(dResultWord)); 
templog.append("\n");
templog.append("Number of correctly identified non-words: " + string(dResultNonWord)); 
templog.append("\n");
templog.append("Total score: " + string(dResult)); 
templog.append("\n");
		
ofile1.open_append (logfile.subject() + "_" + "score.txt"); 
ofile1.print( templog );
ofile1.close();

WaitForAllButtonpress();